;========INITIALISIERUNG des INTERUPTS==========
#define lcdbusy wait-prog+$8484
#define int_buffer int_data-prog+$8484
init_int:
	im 1
	ld hl,$8300					;addr. $8484 als interupt setzen
	ld de,$8301
	ld bc,256
	ld (hl),$84
	ldir

	ld hl,prog					;interupt proggi in andern speicher kopieren
	ld de,$8484
	ld bc,endprog-prog+1
	ldir

	call _zerooop1    			;pic1 file in zop2
	ld hl,pic_file_1
	ld de,op1        
	ld bc,9
	ldir 
	call _chkfindsym 				;nachsehen
	call nc,_delvar   			;lschen
	ld hl,768					;ein bild drin speichern       			
	call _createprog 				
	inc de           
	inc de            
	ld (int_buffer),de			;@pic1 in in_buffer
	
	call _zerooop1    			;pic1 file in zop2
	ld hl,pic_file_2
	ld de,op1        
	ld bc,9
	ldir 
	call _chkfindsym 				;nachsehen
	call nc,_delvar   			;lschen
	ld hl,768					;ein bild drin speichern       			
	call _createprog 				
	inc de           
	inc de            
	ld (int_buffer+2),de			;@pic1 in in_buffer

	ld a,0	
	ld (int_buffer+4),a			;counter in buffer

	ld a,$83	            
	ld i,a
	im 2
	ret

deinit_int:
	im 1                     

	call _zerooop1    			;pic1 file in zop2
	ld hl,pic_file_1
	ld de,op1        
	ld bc,9
	ldir 
	call _chkfindsym 				;nachsehen
	call nc,_delvar   			;lschen
	
	call _zerooop1    			;pic1 file in zop2
	ld hl,pic_file_2
	ld de,op1        
	ld bc,9
	ldir 
	call _chkfindsym 				;nachsehen
	call nc,_delvar   			;lschen
	ret

;===========INTERUPT ROUTINE=================
prog:
	di
	ex af,af'
	exx

;	ld a,$05
;	call lcdbusy
;	out ($10),a

	ld a,(int_buffer+4)			;counter in a
	inc a
	cp 3
	jr nz,next3
	ld a,0
next3:
	ld (int_buffer+4),a			;a zurck in speicher

	cp 0
	jr nz,next_pic2
	ld hl,(int_buffer)
	jr do_copy
next_pic2:
	cp 1
	jr nz,exit_int
	ld hl,(int_buffer+2)
do_copy:

	ld c,$11				;c=out-port
	ld a,12
	ld d,a				;max. spalt4e in d

lb_2:
	ld a,%10000000			;y auf 0
	call lcdbusy
	out ($10),a

	ld a,12				;x auf neue spalte 
	sub d
	or %00100000
	call lcdbusy
	out ($10),a

	ld a,64				;hhe in y
	ld b,a
back_loop1:
	call lcdbusy			;spalte kopieren
	outi
	jr nz,back_loop1

	dec d
	jr nz,lb_2
	jr exit_int
	
exit_int:
;	ld a,$05			;wieder auf x-increment mode fr os
;	call lcdbusy
;	out ($10),A  

	exx                             
	ex af,af'                  
	jp $0038                   

wait: 

	push hl
	pop hl
	inc hl
	dec hl
	ret

int_data:
	.dw $8e29,$8265
	.db 00
endprog:
pic_file_1:
	.db 05,"Z_GREYA",0
pic_file_2:
	.db 05,"Z_GREYB",0

.end
